<?php

namespace App\Twig\Extension;

use App\Repository\TagRepository;
use Symfony\Bundle\SecurityBundle\Security;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

class SnipFilterExtension extends AbstractExtension
{
    public function __construct(
        private readonly TagRepository $tagRepository,
        private readonly Security      $security,
    ) {}

    public function getFunctions(): array
    {
        return [
            new TwigFunction('snipSortOptions', fn() => ['name', 'date']),
            new TwigFunction('snipFilterOptions', fn() => ['all', 'visible', 'hidden', 'archived']),
            new TwigFunction('snipTagOptions', fn() => $this->getSnipTagOptions()),
        ];
    }

    private function getSnipTagOptions(): array
    {
        $tags[null] = 'All tags';
        foreach ($this->tagRepository->findAllByUser($this->security->getUser()) as $tag) {
            $tags[(string)$tag] = (string)$tag;
        }
        return $tags;
    }

}
